using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;

using NetworkCommsDotNet;
using NetworkCommsDotNet.Connections;
using NetworkCommsDotNet.Connections.TCP;
using NetworkCommsDotNet.Connections.UDP;
using NetworkCommsDotNet.DPSBase;
using NetworkCommsDotNet.Tools;

namespace TestProject
{
    /// <summary>
    /// ä  ̽
    /// </summary>
    public abstract class ChatServerBase
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region Field

        /// <summary>
        /// Ʈ ޽ ųʸ
        /// </summary>
        /// <remarks>ä 쿡 ̹ ۼ Ǿ ޽ ϴ ųʸ</remarks>
        protected Dictionary<ShortGuid, ChatMessage> chatMessageDictionary = new Dictionary<ShortGuid, ChatMessage>();

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// ִ  īƮ
        /// </summary>
        private int maximumRelayCount = 3;

        /// <summary>
        /// ޽ ߼ ε
        /// </summary>
        /// <remarks> νϽ  ޽  ϱ  ϴ  ī</remarks>
        private long messageSendIndex = 0;

        /// <summary>
        /// ȣȭ Ű
        /// </summary>
        ///                             
        private string encryptionKey = "12345678901234567890123456789012345678"; // ȣȭ Ű 38ڸ ؾ Ѵ.

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  Ÿ - ConnectionType

        /// <summary>
        ///  Ÿ
        /// </summary>
        public ConnectionType ConnectionType { get; set; }

        #endregion
        #region  ȭ - DataSerializer

        /// <summary>
        ///  ȭ
        /// </summary>
        public DataSerializer DataSerializer { get; set; }

        #endregion
        #region  IP ּ - ServerIPAddress

        /// <summary>
        ///  IP ּ
        /// </summary>
        public string ServerIPAddress { get; set; }

        #endregion
        #region  Ʈ - ServerPort

        /// <summary>
        ///  Ʈ
        /// </summary>
        public int ServerPort { get; set; }

        #endregion
        #region ø - LocalName

        /// <summary>
        /// ø
        /// </summary>
        public string LocalName { get; set; }

        #endregion
        #region   Ȱȭ  - LocalServerEnabled

        /// <summary>
        ///   Ȱȭ 
        /// </summary>
        public bool LocalServerEnabled { get; set; }

        #endregion
        #region ȣȭ Ȱȭ  - EncryptionEnabled

        /// <summary>
        /// ȣȭ Ȱȭ 
        /// </summary>
        public bool EncryptionEnabled { get; set; }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region ù° ʱȭ  - IsFirstInitialized

        /// <summary>
        /// ù° ʱȭ 
        /// </summary>
        protected bool IsFirstInitialized { get; set; }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - ChatServerBase(localName, connectionType)

        /// <summary>
        /// 
        /// </summary>
        public ChatServerBase(string localName, ConnectionType connectionType)
        {
            LocalName      = localName;
            ConnectionType = connectionType;

            ServerIPAddress     = string.Empty;
            ServerPort          = 10000;
            LocalServerEnabled  = false;
            EncryptionEnabled   = false;
            IsFirstInitialized  = true;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  ϱ - RefreshConfiguration()

        /// <summary>
        ///  ϱ
        /// </summary>
        public void RefreshConfiguration()
        {
            if(IsFirstInitialized)
            {
                IsFirstInitialized = false;

                NetworkComms.AppendGlobalIncomingPacketHandler<ChatMessage>("ChatMessage", ProcessChatMessageReceived);

                NetworkComms.AppendGlobalConnectionCloseHandler(ProcessConnectionClosed);
            }

            NetworkComms.DefaultSendReceiveOptions = new SendReceiveOptions
            (
                DataSerializer,
                NetworkComms.DefaultSendReceiveOptions.DataProcessors,
                NetworkComms.DefaultSendReceiveOptions.Options
            );

            if
            (
                EncryptionEnabled &&
                !NetworkComms.DefaultSendReceiveOptions.DataProcessors.Contains(DPSManager.GetDataProcessor<RijndaelPSKEncrypter>())
            )
            {
                RijndaelPSKEncrypter.AddPasswordToOptions(NetworkComms.DefaultSendReceiveOptions.Options, this.encryptionKey);

                NetworkComms.DefaultSendReceiveOptions.DataProcessors.Add(DPSManager.GetDataProcessor<RijndaelPSKEncrypter>());
            }
            else if
            (
                !EncryptionEnabled &&
                NetworkComms.DefaultSendReceiveOptions.DataProcessors.Contains(DPSManager.GetDataProcessor<RijndaelPSKEncrypter>())
            )
            {
                NetworkComms.DefaultSendReceiveOptions.DataProcessors.Remove(DPSManager.GetDataProcessor<RijndaelPSKEncrypter>());
            }

            if(LocalServerEnabled && ConnectionType == ConnectionType.TCP && !Connection.Listening(ConnectionType.TCP))
            {
                #region   Ȱȭ ǰ  Ÿ TCP TCP  ʴ  óѴ.

                if(Connection.Listening(ConnectionType.UDP))
                {
                    AppendLineToChatHistory(" 尡 Ǿϴ.   ϴ.");

                    NetworkComms.Shutdown();
                }
                else
                {
                    AppendLineToChatHistory("  尡 Ȱȭ Ǿϴ.   ϴ.");

                    NetworkComms.Shutdown();
                }

                Connection.StartListening(ConnectionType.TCP, new IPEndPoint(IPAddress.Any, 0));

                AppendLineToChatHistory("TCP   մϴ :");

                foreach(IPEndPoint listenEndPoint in Connection.ExistingLocalListenEndPoints(ConnectionType.TCP))
                {
                    AppendLineToChatHistory(listenEndPoint.Address + ":" + listenEndPoint.Port);
                }

                AppendLineToChatHistory(Environment.NewLine);

                #endregion
            }
            else if(LocalServerEnabled && ConnectionType == ConnectionType.UDP && !Connection.Listening(ConnectionType.UDP))
            {
                #region   Ȱȭ ǰ  Ÿ UDP UDP  ʴ  óѴ.

                if(Connection.Listening(ConnectionType.TCP))
                {
                    AppendLineToChatHistory(" 尡 Ǿϴ.   ϴ.");

                    NetworkComms.Shutdown();
                }
                else
                {
                    AppendLineToChatHistory("  尡 Ȱȭ Ǿϴ.   ϴ.");

                    NetworkComms.Shutdown();
                }

                Connection.StartListening(ConnectionType.UDP, new IPEndPoint(IPAddress.Any, 0));

                AppendLineToChatHistory("UDP   մϴ :");

                foreach(IPEndPoint listenEndPoint in Connection.ExistingLocalListenEndPoints(ConnectionType.UDP))
                {
                    AppendLineToChatHistory(listenEndPoint.Address + ":" + listenEndPoint.Port);
                }

                AppendLineToChatHistory(Environment.NewLine);

                #endregion
            }
            else if(!LocalServerEnabled && (Connection.Listening(ConnectionType.TCP) || Connection.Listening(ConnectionType.UDP)))
            {
                #region   Ȱȭ ǰ TCP UDP ϴ  óѴ.

                NetworkComms.Shutdown();

                AppendLineToChatHistory("  尡 Ȱȭ Ǿϴ.   ϴ.");
                AppendLineToChatHistory(Environment.NewLine);

                #endregion
            }
            else if
            (
                !LocalServerEnabled &&
                (
                    (
                        ConnectionType == ConnectionType.UDP &&
                        NetworkComms.GetExistingConnection(ConnectionType.TCP).Count > 0
                    ) ||
                    (
                        ConnectionType == ConnectionType.TCP &&
                        NetworkComms.GetExistingConnection(ConnectionType.UDP).Count > 0
                    )
                )
            )
            {
                #region   Ȱȭ ǰ  Ÿ UDP̰ TCP  ְų  Ÿ TCP̰ UDP  ִ  óѴ.

                NetworkComms.Shutdown();

                AppendLineToChatHistory(" 尡 Ǿϴ.   ϴ.");
                AppendLineToChatHistory(Environment.NewLine);

                #endregion
            }
        }

        #endregion
        #region ޽ ۽ϱ - SendMessage(message)

        /// <summary>
        /// ޽ ۽ϱ
        /// </summary>
        /// <param name="message">޽</param>
        public void SendMessage(string message)
        {
            if(message.Trim() == string.Empty)
            {
                return;
            }

            ConnectionInfo serverConnectionInfo = null;

            if(ServerIPAddress != string.Empty)
            {
                try
                {
                    serverConnectionInfo = new ConnectionInfo(ServerIPAddress, ServerPort);
                }
                catch(Exception)
                {
                    ShowMessage(" IP  Ʈ Ľ ߽ϴ.  ùٸ Ȯϰ ٽ õϽʽÿ.");

                    return;
                }
            }

            ChatMessage chatMessage = new ChatMessage
            (
                NetworkComms.NetworkIdentifier,
                LocalName,
                message,
                this.messageSendIndex++
            );

            lock(this.chatMessageDictionary)
            {
                this.chatMessageDictionary[NetworkComms.NetworkIdentifier] = chatMessage;
            }

            AppendLineToChatHistory(chatMessage.SourceName + " - " + chatMessage.Message);

            ClearInputLine();

            if(serverConnectionInfo != null)
            {
                try
                {
                    if(ConnectionType == ConnectionType.TCP)
                    {
                        TCPConnection.GetConnection(serverConnectionInfo).SendObject("ChatMessage", chatMessage);
                    }
                    else if(ConnectionType == ConnectionType.UDP)
                    {
                        UDPConnection.GetConnection
                        (
                            serverConnectionInfo,
                            UDPOptions.None
                        ).SendObject("ChatMessage", chatMessage);
                    }
                    else
                    {
                        throw new Exception("ȿ   Ÿ Ǿϴ.");
                    }
                }
                catch(CommsException)
                {
                    AppendLineToChatHistory
                    (
                        " : ޽ ߼    ߻߽ϴ : " +
                        serverConnectionInfo +
                        ".  Ȯϰ ٽ õϽʽÿ."
                    );
                }
                catch(Exception)
                {
                    AppendLineToChatHistory
                    (
                        " : ޽ ߼  Ϲ  ߻߽ϴ : " +
                        serverConnectionInfo +
                        ".  Ȯϰ ٽ õϽʽÿ."
                    );
                }
            }

            List<ConnectionInfo> otherConnectionInfoList;

            if(serverConnectionInfo != null)
            {
                otherConnectionInfoList =
                (
                    from  current in NetworkComms.AllConnectionInfo()
                    where current.RemoteEndPoint != serverConnectionInfo.RemoteEndPoint
                    select current
                ).ToList();
            }
            else
            {
                otherConnectionInfoList = NetworkComms.AllConnectionInfo();
            }

            foreach(ConnectionInfo otherConnectionInfo in otherConnectionInfoList)
            {
                try
                {
                    if(ConnectionType == ConnectionType.TCP)
                    {
                        TCPConnection.GetConnection(otherConnectionInfo).SendObject("ChatMessage", chatMessage);
                    }
                    else if(ConnectionType == ConnectionType.UDP)
                    {
                        UDPConnection.GetConnection
                        (
                            otherConnectionInfo,
                            UDPOptions.None
                        ).SendObject("ChatMessage", chatMessage);
                    }
                    else
                    {
                        throw new Exception("ȿ   Ÿ Ǿϴ.");
                    }
                }
                catch(CommsException)
                {
                    AppendLineToChatHistory
                    (
                        " : ޽ ߼    ߻߽ϴ : " +
                        otherConnectionInfo +
                        ".  Ȯϰ ٽ õϽʽÿ."
                    );
                }
                catch(Exception)
                {
                    AppendLineToChatHistory
                    (
                        " : ޽ ߼  Ϲ  ߻߽ϴ : " +
                        otherConnectionInfo +
                        ".  Ȯϰ ٽ õϽʽÿ."
                    );
                }
            }

            return;
        }

        #endregion

        #region ä 丮  ߰ϱ - AppendLineToChatHistory(message)

        /// <summary>
        /// ä 丮  ߰ϱ
        /// </summary>
        /// <param name="message">޽</param>
        public abstract void AppendLineToChatHistory(string message);

        #endregion
        #region ä 丮  - ClearChatHistory()

        /// <summary>
        /// ä 丮 
        /// </summary>
        public abstract void ClearChatHistory();

        #endregion
        #region Է   - ClearInputLine()

        /// <summary>
        /// Է  
        /// </summary>
        public abstract void ClearInputLine();

        #endregion
        #region ޽ ֱ - ShowMessage(message)

        /// <summary>
        /// ޽ ֱ
        /// </summary>
        /// <param name="message">޽</param>
        public abstract void ShowMessage(string message);

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region ä ޽ Ž óϱ - ProcessChatMessageReceived(packetHeader, connection, chatMessage)

        /// <summary>
        /// ä ޽ Ž óϱ
        /// </summary>
        /// <param name="packetHeader">Ŷ </param>
        /// <param name="connection"></param>
        /// <param name="chatMessage">ä ޽</param>
        protected virtual void ProcessChatMessageReceived(PacketHeader packetHeader, Connection connection, ChatMessage chatMessage)
        {
            lock(this.chatMessageDictionary)
            {
                if(this.chatMessageDictionary.ContainsKey(chatMessage.SourceIdentifier))
                {
                    if(this.chatMessageDictionary[chatMessage.SourceIdentifier].MessageIndex < chatMessage.MessageIndex)
                    {
                        AppendLineToChatHistory(chatMessage.SourceName + " - " + chatMessage.Message);

                        this.chatMessageDictionary[chatMessage.SourceIdentifier] = chatMessage;
                    }
                }
                else
                {
                    this.chatMessageDictionary.Add(chatMessage.SourceIdentifier, chatMessage);

                    AppendLineToChatHistory(chatMessage.SourceName + " - " + chatMessage.Message);
                }
            }

            if(chatMessage.RelayCount < this.maximumRelayCount)
            {
                Connection[] allRelayConnections =
                (
                    from  current in NetworkComms.GetExistingConnection()
                    where current != connection
                    select current
                ).ToArray();

                chatMessage.IncrementRelayCount();

                foreach(Connection relayConnection in allRelayConnections)
                {
                    try
                    {
                        relayConnection.SendObject("ChatMessage", chatMessage);
                    }
                    catch(CommsException)
                    {
                    }
                }
            }
        }

        #endregion
        #region  ݴ  óϱ - ProcessConnectionClosed(connection)

        /// <summary>
        ///  ݴ  óϱ
        /// </summary>
        /// <param name="connection"></param>
        private void ProcessConnectionClosed(Connection connection)
        {
            lock(this.chatMessageDictionary)
            {
                ShortGuid remoteSourceIdentifier = connection.ConnectionInfo.NetworkIdentifier;

                if(this.chatMessageDictionary.ContainsKey(remoteSourceIdentifier))
                {
                    AppendLineToChatHistory
                    (
                        string.Format
                        (
                            "'{0}'  ϴ.",
                            this.chatMessageDictionary[remoteSourceIdentifier].SourceName
                        )
                    );
                }
                else
                {
                    AppendLineToChatHistory(string.Format("'{0}  ϴ.", connection.ToString()));
                }

                this.chatMessageDictionary.Remove(connection.ConnectionInfo.NetworkIdentifier);
            }
        }

        #endregion

        #region  ϱ - PrintUsageInstructions()

        /// <summary>
        ///  ϱ
        /// </summary>
        public void PrintUsageInstructions()
        {
            AppendLineToChatHistory("");
            AppendLineToChatHistory("ä   :");
            AppendLineToChatHistory("");
            AppendLineToChatHistory("ܰ 1.   ̻ ä  α׷ ϴ.");
            AppendLineToChatHistory("ܰ 2.   α׷   带 Ȱȭմϴ ( ).");
            AppendLineToChatHistory("ܰ 3.   α׷    IP  Ʈ  Էմϴ.");
            AppendLineToChatHistory("ܰ 4. ä Ͻʽÿ.");
            AppendLineToChatHistory("");
            AppendLineToChatHistory(" :  ù ° ޽ ۽ ˴ϴ.");
            AppendLineToChatHistory("");
        }

        #endregion
    }
}